import psycopg2

from flask import g
from pathlib import Path
from psycopg2.extras import RealDictCursor


def get_db():
    if "db" not in g:
        # TODO: Make this configurable and use a default that works
        # on the pool computers.
        g.db = psycopg2.connect("host=localhost dbname=garfield")

    return g.db


def close_db(e=None):
    db = g.pop("db", None)
    if db is not None:
        db.close()


def init_app(app):
    app.teardown_appcontext(close_db)


def run_query(query_name, params=None):
    db = get_db()
    
    query = (Path(__file__).parent / Path(query_name)).read_text()

    cursor = db.cursor(cursor_factory=RealDictCursor)
    try:
        cursor.execute(query, params)
        return cursor
    except:
        db.rollback()
        raise
