from flask import Blueprint, render_template, session

from . import db


bp = Blueprint("inventory", __name__, url_prefix="/inventory")


@bp.route("/")
def index():
    location = session.get("location", None)
    items = db.run_query("get_inventory_overview.sql", {
        "location_id": None if location is None else location["location_id"]
    }).fetchall()

    return render_template("inventory/index.html", **{
        "items": items
    })


@bp.get("/<item_id>")
def read_item(item_id: int):
    item = db.run_query("get_item_by_id.sql", {
        "item_id": item_id
    }).fetchone()

    snacks = db.run_query("get_snacks_by_item_id.sql", {
        "item_id": item_id
    }).fetchall()

    same_barcode_items = db.run_query("get_items_by_barcode.sql", {
        "item_barcode": item["item_barcode"],
        "location_id": item["location"]
    }).fetchall()

    return render_template("inventory/read_item.html", **{
        "item": item,
        "snacks": snacks,
        "same_barcode_items": same_barcode_items
    })
